<template>
	<f7-page 
        name="marketplacelist" 
        @page:beforein="onPageBeforeIn"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Iklan Baris</f7-nav-title>
            <f7-nav-title-large v-if="category != null">{{ convertAmpersand(category.name) }}</f7-nav-title-large>
		</f7-navbar>
        <f7-list class="no-margin-top" media-list no-hairlines v-if="!productLoading && marketplaceProducts.length > 0">
			<f7-list-item
				v-for="(item, index) in marketplaceProducts"
				:key="index"
				:link="`/marketplace/product/${item.id}/`"
			>
				<img v-if="item.medias.length > 0" :src="item.medias[0].url.small" width="48" height="48" class="img-circle" slot="media"/>
				<img v-else :src="require('../assets/no-photo.jpg')" width="48" class="img-circle" slot="media">
				<div slot="title">{{ item.title }}</div>
				<div class="item-after" slot="after-title" v-if="item.author.profile.latitude != null && item.author.profile.longitude != null">
					<f7-icon f7="placemark" size="18px" color="pink"></f7-icon> <span class="distance">{{ distance(currentLocation.latitude, currentLocation.longitude, item.author.profile.latitude, item.author.profile.longitude) }}</span>
				</div>
				<div slot="subtitle">
					<div v-if="item.discount > 0">
						<small class="display-block">
							<s class="color-red">Rp {{ item.price.format(0,0,'.',',') }}</s>
						</small>
						<small class="display-block">Rp {{ calculateDiscount(item.price, item.discount).format(0,0,'.',',') }} / {{ item.unit.name }}</small>
					</div>
					<div v-else>
						<small class="display-block">Rp {{ item.price.format(0,0,'.',',') }} / {{ item.unit.name }}</small>
					</div>
				</div>
				<div slot="text"><small>{{ item.category.name }}</small></div>
			</f7-list-item>            
		</f7-list>
        <f7-block v-else-if="!productLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="remove_shopping_cart" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
		<f7-list media-list no-hairlines v-else-if="productLoading">
            <f7-list-item
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Lorem ipsum dolor sit amet"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, distance } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'MarketplaceList',
    data(){
        return {
            allowInfinite: true,
            showPreloader: true,
            productLoading: true,
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('category', ['category']),
		...mapGetters('product', [
            'marketplaceProducts',
            'pagination'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    methods: {
        dateFormat,
        distance,
        convertAmpersand(text){
            return text.replace(/&amp;/g, '&');
        },
        calculateDiscount(price, discount){
            return price - ((price * discount) / 100);            
        },
        getProducts(page, loadmore){
            const self = this;

            self.$store.dispatch('product/getProducts', {
                category: self.$f7route.params.id,
                page: page,
                perpage: 25,
                latitude: self.currentLocation != null ? self.currentLocation.latitude : null,
				longitude: self.currentLocation != null ? self.currentLocation.longitude : null,
                pageName: 'marketplace',
                loadmore: loadmore,
                only: 'id,title,slug,description,minorder,price,delivery_cost,discount,isdeliverable,isnegotiable,category.id,category.name,category.slug,created,updated,unit.id,unit.name,unit.symbol,author.id,author.profile.fullname,author.profile.store_name,author.profile.store_about,author.profile.store_open,author.profile.store_close,author.profile.latitude,author.profile.longitude,medias'
            }).then(()=>{
                setTimeout(()=>{
                    self.productLoading = false;
                    self.showPreloader = self.pagination.has_next;
                }, 100);
            });
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('category/getCategory', {
                id: self.$f7route.params.id,
                only: 'id,name,slug'
            });

            if(self.currentLocation != null){
                self.getProducts(1, false);
            }else{
                self.productLoading = false;
                self.showPreloader = false;
            }
        },
        onPageRefresh(e, done){
            const self = this;

            if(self.currentLocation != null){
                self.getProducts(1, false);
                done();
            }else{
                self.productLoading = false;
                self.showPreloader = false;
            }
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getProducts(self.pagination.page + 1, true);
                    self.allowInfinite = true;
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
    }
}
</script>
